//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// VIEW - HOST OVERRIDE
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function HostOverridePanel(id) {
    console.log("HostOverridePanel.constructor");
    // mandatory call to parents constructor
    HostOverridePanel.prototype.parentConstructor.apply(this, arguments);

    // bind the update button click
    this.bind(this.panelId + ' .btn', "click", this.handleUpdateClick);
}

extend(HostOverridePanel, BasePanel);

HostOverridePanel.prototype.handleUpdateClick = function(e) {
    var self = this;
    this.ffConfirm($.t("host_name_confirmation"), function(e) {
        var newValue= $(self.panelId + ' input[type=text]').val();
        protocolSetHostNameOverride(newValue, function() {
            console.log("set host override to " + newValue);
            self.showInputAlert(true, $.t("host_name_success", {hostname: newValue}));
        }, function() {
            self.showInputAlert(false, $.t("host_name_failure"));
        });
    });
};

HostOverridePanel.prototype.getModelEventsHandled = function(e) {
    console.log("HostOverridePanel.getModelEventsHandled");
    return [modelEvents.HOST_OVERRIDE_CHANGED];
};

HostOverridePanel.prototype.handleModelChanged = function(type, data) {
    console.log("HostOverridePanel.handleModelChanged");
    switch(type) {
        case modelEvents.HOST_OVERRIDE_CHANGED:
            this.render(data);
    }
};

HostOverridePanel.prototype.render = function(model) {
    $(this.panelId + ' input[type=text]').val(model.hostOverride);
};