//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// VIEW - REVISION STORAGE
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function StoragePanel(id) {
    console.log("StoragePanel.constructor");
    // mandatory call to parents constructor
    StoragePanel.prototype.parentConstructor.apply(this, arguments);
}

extend(StoragePanel, BasePanel);

StoragePanel.prototype.getModelEventsHandled = function(e) {
    console.log("StoragePanel.getModelEventsHandled");
    return [modelEvents.REVISION_CAPACITIES_CHANGED, modelEvents.REVISION_ROOT_CHANGED];
};

StoragePanel.prototype.handleModelChanged = function(type, data) {
    console.log("StoragePanel.handleModelChanged");
    switch(type) {
        case modelEvents.REVISION_CAPACITIES_CHANGED:
            this.renderCapacities(model);
            break;
        case modelEvents.REVISION_ROOT_CHANGED:
            this.renderRevisionRoot(model);
            break;
    }
};

StoragePanel.prototype.renderCapacities = function(model) {
    var capacity = model.revisionSpaceCapacity;
    var free = model.revisionSpaceFree;

    var avail = Math.floor(free/1000000000*10)/10;
    var total = Math.floor(capacity/1000000000*10)/10;
    var used = Math.floor((capacity-free)/1000000000*10)/10;
    $("#storageChartAvailable").append(avail).append("GB");
    $("#storageChartTotal").append(total).append("GB");
    $("#storageChartUsed").append(used).append("GB");

    var data = [
        {
            value: used,
            color:"#FF3333",
            highlight: "#FF8888",
            label: $.t("pie_storage_used")
        },
        {
            value: avail,
            color: "#99FF33",
            highlight: "#BBFF77",
            label: $.t("pie_free_space")
        }
    ];

    // Get context with jQuery - using jQuery's .get() method.
    var ctx = $("#myChart").get(0).getContext("2d");
    var myPieChart = new Chart(ctx).Pie(data);
}

StoragePanel.prototype.renderRevisionRoot = function(model) {
    $(this.panelId + " .well").append($.t("default_domain_success", {domain: model.revisionRoot}));
};