//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// PROTOCOL
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function _statusToModel(model, statusInfo) {
    model.updateRevisionRoot(statusInfo["revision-root"]);
    model.updateHostOverride(statusInfo["host-override"]);
    model.updateDefaultDomain(statusInfo["default-domain"]);
    model.updateRevisionCapacities(statusInfo["revision-space-free"], statusInfo["revision-space-capacity"]);
    model.updateVersion(statusInfo["version"], statusInfo["build"]);
    model.updateCanUpdate(statusInfo["updateable"]);
}

function protocolFetchStatus(model, onSuccess) {

    var params = {
        "cmd": "status",
        "admin": "",
        "password": "",
        "user": ""
    };

    var requestUrl = addParams("/", params);

    var jqXHR = $.get(requestUrl)
        .done(function(resp) {
            _statusToModel(model, resp);
            onSuccess();
        })
        .fail(function() {
            console.log("fetchStatus failure");
        });
}

function protocolSetGlobal(key, value, onSuccess, onFail) {

    var params = {
        "cmd": "set-global"
    };

    params[key] = value;

    var requestUrl = addParams("/secure/", params);

    var jqXHR = $.get(requestUrl)
        .done(function(resp) {
            if (resp.result == true) {
                console.log("protocolSetGlobal " + key + ":" + value + " success");
                onSuccess();
            } else {
                onFail();
                console.log("protocolSetGlobal " + key + ":" + value + " failure");
            }
        })
        .fail(function() {
            onFail();
            console.log("protocolSetGlobal " + key + ":" + value + " failure");
        });
}

function protocolSetHostNameOverride(value, onSuccess, onFail) {
    var self = this;
    protocolSetGlobal("host-override", value, function() {
        model.updateHostOverride(value);
        onSuccess();
    }, onFail);
}

function protocolSetDefaultDomain(value, onSuccess, onFail) {
    protocolSetGlobal("default-domain", value, function() {
        model.updateDefaultDomain(value);
        onSuccess();
    }, onFail);
}