//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// VIEW - BASE PANEL CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function BasePanel(id) {
    console.log("BasePanel.constructor");
    this.panelId = id;

    if (!BasePanel.prototype || !BasePanel.prototype.initialized) {
        console.log("BasePanel.constructor.init");

        // bind the confirmation dialog OK click
        this.bind('#confirmationModal .btn-primary', "click", this.ffHandleConfirm);

        BasePanel.prototype.initialized= true;
    }
}

BasePanel.prototype = {
    initialized: false,

    bind: function(selector, eventType, func) {
        var self = this;
        $(selector).on(eventType, function (e) {
            func.call(self, eventType, e);
        });
    },

    ffConfirm: function(msg, cb) {
        BasePanel.prototype.confirmationCallback = cb;
        $('#confirmationModal .dialogBody').text(msg);
        $('#confirmationModal').modal();
    },

    ffHandleConfirm: function(etype, e) {
        $('#confirmationModal').modal('hide');
        BasePanel.prototype.confirmationCallback.call(this, e);
    },

    ffModelChanged: function(event, data) {
        // jquery allowed us to bury the object into event.data, so we use that to change 'this' accordingly
        var _this = event.data;
        _this.handleModelChanged.call(_this, event.type, data);
    },

    showInputAlert: function(success, txt) {
        var inputSelector = this.panelId + ' .input-info';
        $(inputSelector).empty();
        var alertClass = 'alert-success';
        var glyphType = 'glyphicon-ok';
        if (success==false) {
            alertClass = 'alert-danger';
            glyphType = 'glyphicon-exclamation-sign';
        }
        var htmlAlert = "<div class='alert " + alertClass + " alert-dismissible'>"
            + "<button type='button' class='close' data-dismiss='alert'>&times;</button>"
            + "<span class='glyphicon " + glyphType + "'></span>"
            + txt
            + "</div>";
        $(this.panelId + ' .input-info').append(htmlAlert);
    }
};