/**
 * Created by ilia on 10/14/2016.
 */

$(document).ready(function() {

    var code = gup("code");
    var meta = gup("meta");
    var uid = gup("uid");
    var mspId = gup("mspId");

    function psvFetchStatus(onSuccess) {

        var params = {
            "cmd": "status",
            "admin": "",
            "password": "",
            "user": ""
        };

        var requestUrl = addParams("./", params);

        var jqXHR = $.get(requestUrl)
            .done(function(resp) {
                log("fetchStatus success with: ");
                log(resp);
                onSuccess(resp);
            })
            .fail(function() {
                console.log("fetchStatus failure with " + code);
            });
    }

    function checkboxTextCheck() {
        if (checkbox.checked) {
            checkbox.checked = false;
            sendLogsButton.disabled = true;
        } else {
            checkbox.checked = true;
            sendLogsButton.disabled = false;
        }
    }

    function checkboxCheck() {
        if (checkbox.checked) {
            sendLogsButton.disabled = false;
        } else {
            sendLogsButton.disabled = true;
        }
    }

    function gatheringLogsStart() {
        sendLogsCont.style.display = 'none';
        gatheringCont.style.display = 'block';
        gatheringEnd.style.display = 'none';
        var description = document.getElementById("descriptionData").value;

        $.ajax({
            method: "GET",
            url: "/",
            data: {
                "cmd": "submit-logs",
                "token": code,
                "uid": uid,
                "description": description || undefined,
                "meta": meta || undefined,
                "mspId": mspId || undefined
            },
            dataType: "text"
        }).done(function (resp) {
            console.log("fetchStatus success with: ");
            console.log(resp);
            gatheringLogsEnd();
        }).fail(function (jqXHR, textStatus, ex) {
            console.log("fetchStatus failure status: " + jqXHR.status + " " + textStatus +
                (jqXHR.responseText ? ", response: " + jqXHR.responseText : "") +
                (ex ? ", exception: " + ex : ""));

            showMessage(ERROR_SEND_LOGS, $.t("send_logs_error"));

            gatheringStart.style.display = 'none';
            buttonDone.disabled = false;
        })
    }

    function gatheringLogsEnd() {
        gatheringStart.style.display = 'none';
        gatheringEnd.style.display = 'block';
        buttonDone.disabled = false;
        refNumber.innerHTML = code;
    }



    var checkbox = document.getElementById("sendLogsAgree");
    var sendLogsButton = document.getElementById("sendLogsButton");
    var buttonDone = document.getElementById("buttonDone");
    var buttonCancel = document.getElementById("activButtonCancel");

    // Hide "Cancel" and "Done" buttons for browsers
    if (APP_TYPE === "native") {
        buttonCancel.style.display = 'inline-block';
        buttonDone.style.display = 'inline-block';
    } else {
        buttonCancel.style.display = 'none';
        buttonDone.style.display = 'none';
    }

    var checkboxText = document.getElementById("checkboxText");
    var sendLogsCont = document.getElementById("sendLogsCont");
    var gatheringCont = document.getElementById("gatheringCont");
    var gatheringStart = document.getElementById("gatheringStart");
    var gatheringEnd = document.getElementById("gatheringEnd");
    var refNumber = document.getElementById("refNumber");


    // Set begin states for buttons and the checkbox
    checkbox.checked=false;
    buttonDone.disabled = true;
    sendLogsButton.disabled = true;

    // Add click handlers
    checkboxText.addEventListener("click", checkboxTextCheck);
    checkbox.addEventListener("click", checkboxCheck);
    sendLogsButton.addEventListener("click", gatheringLogsStart);

    initializeLanguage("./locales/__ns__-__lng__.json", function() {
        psvFetchStatus(function(statusInfo) {
            if(isSecured()) {
                setGlobals(statusInfo);
                // stop 'secureonly' css fields from being hidden
                $('.secureonly').removeClass('secureonly');
            } else {
                // if we're not secured, we redirect the user to the secured version of this page
                var securedUrl = generateSecuredUrl();
                log("eventually redirecting user to " + securedUrl);
                redirectUserEventually(securedUrl, REDIRECT_SECONDS);
            }
        });
    });

});

