#!/bin/sh

. /etc/script/lib/command.sh

APKG_PKG_DIR=/usr/local/AppCentral/FileFlex
PID_FILE=/var/run/fileflex.pid

# Lockup for fileflex process. Exit if found
_QnStatus() {
    local _QN_PID=`pgrep fileflex | head -n 1`
    if [[ ! -z "${_QN_PID}" ]]; then
        >&2 echo "Already running"
		exit 1
    fi
}

case $1 in

	start)
		_QnStatus
		# start script here
		cd $APKG_PKG_DIR
		./fileflex >/dev/null 2>&1 &
		echo $! > $PID_FILE
		echo "Started"
		;;

	stop)
		# stop script here
		killall fileflex 2> /dev/null
		killall fileflex.connector 2> /dev/null
		rm -rf $PID_FILE
		echo "Stoped"
		;;

	*)
		echo "usage: $0 {start|stop}"
		exit 1
		;;

esac

exit 0